#include <stdio.h>

  /* Napisite program koji u\v{c}itava prirodne brojeve n i b,
     uz pretpostavku da je b >= 2 (ne treba provjeravati).
     Promatramo znamenke broja n zapisanog u bazi b.
     Po definiciji, znamenka je dobra ako se nalazi uz parnu
     potenciju baze i najveca od svih znamenki je djeljiva s tom
     znamenkom.
     Program treba ispisati produkt svih dobrih znamenki.
     Ako takvih znamenki nema, treba ispisati odgovarajucu poruku.
  */

int main(void) {
    int n, b, ima_dobrih = 0, nn, b_kvadrat, znam;
    int max_znam, prod_dobrih;

    printf("Upisi prirodni broj n i bazu b >= 2:\n");
    scanf("%d%d", &n, &b);

        /* Najveca znamenka. */
    nn = n ;
    max_znam = 0;  // Lazna inicijalizacija.
    while (nn > 0) {
        znam = nn % b;
        if (znam > max_znam)
            max_znam = znam;
        nn = nn / b;
    }

        /* Kvadrat baze (za parne potencije). */
    b_kvadrat = b*b;
    nn = n;

        /* Produkt dobrih znamenki. */
    prod_dobrih = 1;
    while (nn > 0) {
        znam = nn % b;
            /* Izbjegni dijeljenje s nulom! */
        if (znam != 0 && max_znam % znam == 0) {
            ima_dobrih = 1;
            prod_dobrih *= znam;
            }
        nn = nn / b_kvadrat;
    }

    if (ima_dobrih)
        printf(" Produkt dobrih znamenki = %d\n", prod_dobrih);
    else
        printf(" Nema dobrih znamenki.\n");

    return 0;
}
