#include <stdio.h>

  /* Napisite program koji u\v{c}itava prirodne brojeve n i b,
     uz pretpostavku da je b >= 2 (ne treba provjeravati).
     Promatramo znamenke broja n zapisanog u bazi b.
     Po definiciji, znamenka je dobra ako se nalazi uz neparnu
     potenciju baze djeljiva je s najmanjom pozitivnom znamenkom.
     Program treba ispisati sumu svih dobrih znamenki.
     Ako takvih znamenki nema, treba ispisati odgovarajucu poruku.
  */

int main(void) {
    int n, b, ima_dobrih = 0, nn, b_kvadrat, znam;
    int min_poz_znam, suma_dobrih;

    printf("Upisi prirodni broj n i bazu b >= 2:\n");
    scanf("%d%d", &n, &b);

        /* Najmanja pozitivna znamenka. */
    nn = n ;
    min_poz_znam = b;  // Lazna inicijalizacija.
    while (nn > 0) {
        znam = nn % b;
        if (znam > 0 && znam < min_poz_znam)
            min_poz_znam = znam;
        nn = nn / b;
    }

        /* Kvadrat baze i pomak na neparnu potenciju u n. */
    b_kvadrat = b*b;
    nn = n / b;

        /* Suma dobrih znamenki. */
    suma_dobrih = 0;
    while (nn > 0) {
        znam = nn % b;
        if (znam % min_poz_znam == 0) {
            ima_dobrih = 1;
            suma_dobrih += znam;
            }
        nn = nn / b_kvadrat;
    }

    if (ima_dobrih)
        printf(" Suma dobrih znamenki = %d\n", suma_dobrih);
    else
        printf(" Nema dobrih znamenki.\n");

    return 0;
}
