#include <stdio.h>

  /* Napisite program koji u\v{c}itava prirodne brojeve n i b,
     uz pretpostavku da je b >= 2 (ne treba provjeravati).
     Promatramo znamenke broja n zapisanog u bazi b.
     Po definiciji, znamenka je dobra ako se nalazi uz parnu
     potenciju baze i suma svih znamenki je djeljiva s tom znamenkom.
     Program treba ispisati najvecu dobru znamenku.
     Ako takvih znamenki nema, treba ispisati odgovarajucu poruku.
  */

int main(void) {
    int n, b, ima_dobrih = 0, nn, b_kvadrat, znam;
    int suma_znam, max_dobrih;

    printf("Upisi prirodni broj n i bazu b >= 2:\n");
    scanf("%d%d", &n, &b);

        /* Suma svih znamenki. */
    nn = n ;
    suma_znam = 0;
    while (nn > 0) {
        znam = nn % b;
        suma_znam += znam;
        nn = nn / b;
    }

        /* Kvadrat baze (za parne potencije). */
    b_kvadrat = b*b;
    nn = n;

        /* Najveca dobra znamenka. */
    while (nn > 0) {
        znam = nn % b;
            /* Izbjegni dijeljenje s nulom! */
        if (znam != 0 && suma_znam % znam == 0)
            if (ima_dobrih == 0) {
                ima_dobrih = 1;
                max_dobrih = znam;
            }
            else
                if (znam > max_dobrih)
                    max_dobrih = znam;
        nn = nn / b_kvadrat;
    }

    if (ima_dobrih)
        printf(" Najveca dobra znamenka = %d\n", max_dobrih);
    else
        printf(" Nema dobrih znamenki.\n");

    return 0;
}
