#include <stdio.h>

  /* Napisite program koji u\v{c}itava prirodne brojeve n i b,
     uz pretpostavku da je b >= 2 (ne treba provjeravati).
     Promatramo znamenke broja n zapisanog u bazi b.
     Po definiciji, znamenka je dobra ako se nalazi uz neparnu
     potenciju baze i vodeca znamenka (uz najvisu potenciju) je
     djeljiva s tom znamenkom.
     Program treba ispisati najmanju dobru znamenku.
     Ako takvih znamenki nema, treba ispisati odgovarajucu poruku.
  */

int main(void) {
    int n, b, ima_dobrih = 0, nn, b_kvadrat, znam;
    int vod_znam, min_dobrih;

    printf("Upisi prirodni broj n i bazu b >= 2:\n");
    scanf("%d%d", &n, &b);

        /* Vodeca znamenka. */
    nn = n ;
    while (nn >= b)
        nn = nn / b;
    vod_znam = nn;

        /* Kvadrat baze i pomak na neparnu potenciju u n. */
    b_kvadrat = b*b;
    nn = n / b;

        /* Najmanja dobra znamenka. */
    while (nn > 0) {
        znam = nn % b;
            /* Izbjegni dijeljenje s nulom! */
        if (znam != 0 && vod_znam % znam == 0)
            if (ima_dobrih == 0) {
                ima_dobrih = 1;
                min_dobrih = znam;
            }
            else
                if (znam < min_dobrih)
                    min_dobrih = znam;
        nn = nn / b_kvadrat;
    }

    if (ima_dobrih)
        printf(" Najmanja dobra znamenka = %d\n", min_dobrih);
    else
        printf(" Nema dobrih znamenki.\n");

    return 0;
}
